#version 430 core

in vec2 TexCoords;

out vec4 color;

layout (binding = 3) uniform sampler2D scene;
layout (binding = 4) uniform sampler2D bloomBlur;

uniform bool bloom;
uniform float exposure;

void main() {
	const float gamma = 2.2;
	vec3 hdrC = texture(scene, TexCoords).rgb;
	vec3 bloomC = texture(bloomBlur, TexCoords).rgb;
	if(bloom) {
		hdrC += bloomC;
	}
	vec3 r = vec3(1.0) - exp(-hdrC * exposure);
	r = pow(r, vec3(1.0 / gamma));
     	color = vec4(r, 1.0);
}

